﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buzz.MachineInterface;
using BuzzGUI.Interfaces;
using BuzzGUI.Common;
using BuzzGUI.Common.InterfaceExtensions;

namespace patternist
{
    class BuzzListener
    {
        PatternistMachine patternistMachine;
        ISong song;

        public BuzzListener(PatternistMachine _patternistMachine)
        {
            patternistMachine = _patternistMachine;
            song = Global.Buzz.Song;
            song.SequenceAdded += new Action<int>(song_SequenceEvent);
            song.SequenceChanged += new Action<int>(song_SequenceEvent);
            song.SequenceRemoved += new Action<int>(song_SequenceEvent);
            song.MachineRemoved += new Action<IMachine>(song_MachineRemoved);
        }

        void song_SequenceEvent(int index)
        {
            patternistMachine.assignments.ToList().ForEach(a => a.updateSequence());
        }

        void song_MachineRemoved(IMachine mac)
        {
            patternistMachine.assignments.ToList().ForEach(
                a => { 
                    if (a.TargetMacName == mac.Name) 
                        patternistMachine.assignments.Remove(a); 
                }
            );
        }
    }
}
