﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buzz.MachineInterface;

namespace patternist
{
    class Track
    {
        PatternistMachine patternistMachine;
        Note noteToPlay;
        int noteToRelease;
        bool trigger;

        public Track(PatternistMachine _patternistMachine)
        {
            patternistMachine = _patternistMachine;
        }

        public void Note(Note v)
        {
            noteToPlay = v;
            trigger = true;
        }

        void Trigger()
        {
            if (noteToPlay.Value != 255)
            {
                patternistMachine.MidiNote(1, noteToPlay.ToMIDINote(), 100);
                noteToRelease = noteToPlay.ToMIDINote();
            }
            else if (noteToRelease != 0)
            {
                patternistMachine.MidiNote(1, noteToRelease, 0);
                noteToRelease = 0;
            }
        }

        public void Work()
        {
            if (trigger)
            {
                Trigger();
                trigger = false;
            }
        }
    }
}